import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
/**
 * Write a description of class Block here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Block  extends Interactable
{
    GreenfootImage image = new GreenfootImage(20,20);
    int mass;
    int x,y;
    float xs, ys;
    boolean canboom = false;
    boolean justHit = false;
    int type;
    boolean remove = false;

    public Block(int size_x, int size_y, int type)
    {
        this.type = type;
        /**
         * type 1 = red
         * type 2 = blue
         */
        if(type == 1)
            image.setColor(Color.RED);
        if(type == 2)
            image.setColor(Color.BLUE);

        image.scale(size_x, size_y);
        image.fillRect(0, 0, size_x, size_y);
        image.setColor(Color.BLACK);
        image.drawRect(0, 0, size_x-1, size_y-1);

        if(type == 1)
            image.setColor(new Color(255,55,55));
        if(type == 2)
            image.setColor(new Color(55,55,255));

        image.fillRect(image.getWidth()-20, image.getHeight()/3, size_y/3, size_x/3);

        setImage(image);

        mass = size_x * size_y;
    }

    /**
     * Act - do whatever the Block wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        if(((myWorld) getWorld()).onGround(x-image.getWidth()/2+1, y))
            x++;
        if(((myWorld) getWorld()).onGround(x+image.getWidth()/2-1, y))
            x--;
        if(((myWorld) getWorld()).onGround(x, y+image.getHeight()/2-1))
            y--;
        if(((myWorld) getWorld()).onGround(x, y-image.getHeight()/2+1))
            y++;
        if(xs > -0.4 && xs < 0.4)
        {
            if(getRotation() < 180 && getRotation() != 90)
            {
                setRotation(getRotation()-1);
            }
            if(getRotation() > 180 && getRotation() != 270)
            {
                setRotation(getRotation()+1);
            }
        }
        else
            setRotation(getRotation()+(int)xs);

        if(!((myWorld) getWorld()).onGround(x-image.getWidth()/2, y) && !((myWorld) getWorld()).onGround(x+image.getWidth()/2, y))
        {
            justHit = true;
            if(xs > 0)
                xs -= 0.03;
            if(xs < 0)
                xs += 0.03;
        }
        else if(justHit)
        {
            justHit = false;
            xs = 0;
        }

        if(!((myWorld) getWorld()).onGround(x, y+image.getHeight()/2))
        {
            canboom = false;

            if(ys <= 0)
                ys += 0.2;
            if(ys > 0)
                ys += 0.2;
        }
        else if(!canboom)
        {
            canboom = true;
            ys = 0;
        }
        x += xs;
        y += ys;

        setLocation(x, y);

        exit();

        if(remove)
        {
            if(this.type==1)
                ((myWorld) getWorld()).type_one--;
            if(this.type==2)
                ((myWorld) getWorld()).type_two--;
            getWorld().removeObject(this);
            return;
        }
    }    

    public void exit()
    {
        Goal goal = (Goal) getOneIntersectingObject(Goal.class);
        if(goal != null && goal.type == this.type && getImage().getTransparency()>0)
        {
            getImage().setTransparency(getImage().getTransparency()-5);
        }
        if(goal == null)
        {
            getImage().setTransparency(255);
        }
        if(goal != null && goal.type == this.type && getImage().getTransparency()<=0)
        {
            remove = true;
        }
    }

    protected void addedToWorld(World world)
    {
        x = getX();
        y = getY();

        if(type==1)
            ((myWorld) getWorld()).type_one++;
        if(type==2)
            ((myWorld) getWorld()).type_two++;
    }
}
